<?php
/*---------------------------------------------------+
| PHP-Fusion 6 Content Management System
+----------------------------------------------------+
| Copyright  2002 - 2005 Nick Jones
| http://www.php-fusion.co.uk/
+----------------------------------------------------+
| Released under the terms & conditions of v2 of the
| GNU General Public License. For details refer to
| the included gpl.txt file or visit http://gnu.org
+----------------------------------------------------*/
require_once BASEDIR."maincore.php";
require_once "ts_include.php";

// Check if locale file is available matching the current site locale setting.
if (file_exists(INFUSIONS."ts_monitor/locale/".$settings['locale'].".php")) {
	// Load the locale file matching the current site locale setting.
	include INFUSIONS."ts_monitor/locale/".$settings['locale'].".php";
} else {
	// Load the infusion's default locale file.
	include INFUSIONS."ts_monitor/locale/English.php";
}
// Look up php-fusions user info here!
$username = $userdata['user_name'];

$socket = getSocket($serverAddress, $serverQueryPort, $errno, $errstr, 3);
if($socket == false) {
// Make panel table to report errors
openside(TS_PANELHEAD);
$content .= TS_ERROR_CONNECT."<br>\n";
$content .= TS_ERROR_NUMBER.": ".$errno."<br>\n";
$content .= TS_ERROR_DESCRIPTION.": ".$errstr."<br>\n";
echo $content;
closeside();
return;
}

// select the one and only running server on the stored port and check OK.
sendQuery($socket, "sel ".$serverUDPPort);
if(!getOK($socket)) {
	die("Server didn't answer &quot;OK&quot; after last command. Aborting.");
}

openside(TS_PANELHEAD);
// Get Player Array
$playerList = GetPlayers($socket);
// Get Channel Array
$channelList = GetChannels($socket);

// display channel list
$content .= "<table width='100%'>\n";
$counter = 0;
foreach($channelList as $channelInfo) {
// default channel?
	if($channelInfo[isdefault] == 1) {
		$channelname = $channelInfo[channelname];
	} else {
		$channelname = $channelInfo[channelname];
	}

//Future Feature - based on Lentil's code
//Set indent based on subchannel status
//    if ($channelInfo[parent] == -1 )  $cspan = 1;
//    else					  $cspan = 2;

// Build up channel info from flags
    $clabel = ChannelFlags($channelInfo[cflags]);

// Count up players in each channel.
	$playercount = 0;
    foreach($playerList as $playerInfo) {
		  if ($channelInfo[channelid] == $playerInfo[channelid]) {
			$channelInfo[currentplayers] = $playercount++;
		  }    
	}

// Only show populated channels, unless the "Show empty Channels" option is set in the admin panel.
// Also, corrected the display of the 'header' line, which would show up as a channel.
	if ( $playercount > 0 || $show_empty == '1' ) {
		$content .= '<tr><td><img src="'.INFUSIONS.'ts_monitor/images/ts_channel.gif" border="0"></td><td colspan="2" valign="middle"><font size="-3">'.$channelname."<br>$clabel</font></td><td>($playercount/$channelInfo[maxplayers])</td></tr>";
	}

// Render Player names and info
	foreach ($playerList as $playerInfo) {
		if ($channelInfo[channelid] == $playerInfo[channelid]) {
		$plabel = PlayerFlags($playerInfo);
		$pimage = PlayerImage($playerInfo);
			$content .= '<tr><td></td><td colspan=1><img src="'.INFUSIONS.'ts_monitor/images/'.$pimage['image'].'" alt="'.$pimage['AltText'].'" border="0" align=left></td><td valign="middle"><font size="-3">'.$playerInfo[playername]."<br>$plabel</font></td></tr>\n";
		}
	}
$counter++;
}
// No channels added to the array.
if($counter == 0 ) $content .= '<tr><td colspan="4" align="CENTER">No channels</td></tr>\n';
// Close table
$content .= "</table>\n";

// close connection to teamspeak server
closeSocket($socket);

// Display "Sign-In" form if user is logged on to the site. Populate this with nickname, and potentially username/password at later time.
if (iMEMBER) { 
	$content .= "<hr><br><form name=\"ts_monitor\">\n";
	$content .= "<input type='text' name=\"NICKNAME\" value='$username'><br>".TS_NICKNAME."\n";
	$content .= "<br><br>\n";
	$content .= "<input type='text' name=\"LOGINNAME\"><br>".TS_LOGIN."\n";
	$content .= "<br>\n";
	$content .= "<input type='text' name=\"PASSWORD\"><br>".TS_PASSWORD."\n";
	$content .= "<br>\n";
	$content .= "<center><input type='button' value=\"Connect\" onClick=\"location.href='teamspeak://$serverAddress: $serverUDPPort/nickname=' + ts_monitor.NICKNAME.value \"></center>\n";
	$content .= "<br>\n";
	$content .= "</form>\n";
	$content .="<center><a href=\"http://www.goteamspeak.com\"><img src=\"https://sales.tritoncia.com/images/link_to_teamspeak.gif\" border=\"0\" alt=\"Go to Teamspeak.com\"></a></center>\n"
	."";
}

// Print out the collected HTML
echo $content;
// Close Panel
closeside();

require_once BASEDIR."side_right.php";
require_once BASEDIR."footer.php";
?>