<?php
/*---------------------------------------------------+
| PHP-Fusion 6 Content Management System
+----------------------------------------------------+
| Copyright  2002 - 2005 Nick Jones
| http://www.php-fusion.co.uk/
+----------------------------------------------------+
| Released under the terms & conditions of v2 of the
| GNU General Public License. For details refer to
| the included gpl.txt file or visit http://gnu.org
+----------------------------------------------------*/
require_once "../../maincore.php";
require_once BASEDIR."subheader.php";
require_once ADMIN."navigation.php";
require_once "ts_include.php";

if (!checkrights("IP")) fallback("../index.php");

// Check if locale file is available matching the current site locale setting.
if (file_exists(INFUSIONS."ts_monitor/locale/".$settings['locale'].".php")) {
	// Load the locale file matching the current site locale setting.
	include INFUSIONS."ts_monitor/locale/".$settings['locale'].".php";
} else {
	// Load the infusion's default locale file.
	include INFUSIONS."ts_monitor/locale/English.php";
}

// Get variables from settings table
	$result = dbquery("SELECT * FROM ".DB_PREFIX."ts_monitor LIMIT 1");
		while ($data = dbarray($result)) {
			$server_id = $data['server_id'];
			$serverAddress = $data['serverAddress'];
			$serverName = $data['serverName'];
			$serverQueryPort = $data['serverQueryPort'];
			$serverUDPPort = $data['serverUDPPort'];
			$show_empty = $data['show_empty'];
			$count++;
		}	
	$result = dbquery("SELECT * FROM ".DB_PREFIX."panels WHERE panel_filename = 'ts_monitor'");
		while ($data = dbarray($result)) {
			$ts_status = $data['panel_status'];
			$count++;
		}
$socket = getSocket($serverAddress, $serverQueryPort, $errno, $errstr, 3);		

if($socket == false) {
	opentable(TS_FAILED);
	$content .= TS_ERROR_CONNECT."<br>\n";
	$content .= TS_ERROR_NUMBER.": ".$errno."<br>\n";
	$content .= TS_ERROR_DESCRIPTION.": ".$errstr."<br>\n";
	echo $content;
	closetable();
	echo "<br>";
	
//Put up the link for setting connections.
	opentable(TS_LINKS);
	echo TS_ERROR_WARNING."<br><br>";
	echo "<a href='ts_monitor_settings.php'>".TS_SETTINGS."</a>\n";
	closetable();	
	return;
}
// select the one and only running server on port set in Configuration
sendQuery($socket, "sel ".$serverUDPPort);

////////////////////////////////////////////////////////////////////
// Player Info Table.
opentable(TS_ACTIVEUSERS);
// retrieve answer "OK"
if(!getOK($socket)) { die(TS_ERROR_OK); }
$playerList = GetPlayers($socket);

echo "<table width='100%'>";
	echo "<tr>";
	echo "<td align='center'><b>".TS_USERNAME."</b></td>\n";
	echo "<td align='center'><b>".TS_CHANNELID."</b></td>\n";
	echo "<td align='center'><b>".TS_CHANNEL_PRIVS."</b></td>\n";
	echo "<td align='center'><b>".TS_SERVER_PRIVS."</b></td>\n";
	echo "<td align='center'><b>".TS_TOTALTIME."</b></td>\n";
	echo "<td align='center'><b>".TS_IDLE."</b></td>\n";
	echo "</tr>";
	
foreach ($playerList as $playerinfo) {
	if($playerinfo['playername'] != "ic"){ // Prevent header info from listing
		echo "<tr>";
		echo "<td align='center'>".$playerinfo['playername']."</td>\n";
		echo "<td align='center'>".$playerinfo['channelid']."</td>\n";
		echo "<td align='center'>".$playerinfo['cprivs']."</td>\n";
		echo "<td align='center'>".$playerinfo['pprivs']."</td>\n";
		echo "<td align='center'>".round($playerinfo['totaltime'] / 60, 2)." </td>\n";
		echo "<td align='center'>".$playerinfo['idletime']."</td>\n";
		// Build link to kick player while skipping header.
		echo "</tr>";
	} // End If
} //End foreach

echo "</table>";
closetable(); //End Player Info Table

echo "<br>";
//////////////////////////////////////////////////////////////

opentable(TS_CHANNELLIST);

	$channelList = GetChannels($socket);
	echo "<table width='100%'>";
		echo "<tr>";
		echo "<td align='center'><b>".TS_CHANNELNAME."</b></td>\n";
		echo "<td align='center'><b>".TS_CHANNELID."</b></td>\n";
		echo "<td align='center'><b>".TS_CHANNELPARENT."</b></td>\n";
		echo "<td align='center'><b>".TS_CHANNELFLAGS."</b></td>\n";
		echo "<td align='center'><b>".TS_CHANNELMAXPLAYERS."</b></td>\n";
		echo "<td align='center'><b>".TS_CHANNELTOPIC."</b></td>\n";
//		echo "<td align='center'><b>".TS_CHANNELPLAYERCOUNT."</b></td>\n";
		echo "</tr>";
		
	foreach ($channelList as $channelinfo) {
		echo "<tr>";
		echo "<td align='center'>".$channelinfo['channelname']."</td>\n";
		echo "<td align='center'>".$channelinfo['channelid']."</td>\n";
		echo "<td align='center'>".$channelinfo['parent']."</td>\n";
		echo "<td align='center'>".ChannelFlags($channelinfo['cflags'])."</td>\n";
		echo "<td align='center'>".$channelinfo['maxplayers']." </td>\n";
		echo "<td align='center'>".$channelinfo['topic']."</td>\n";
//		echo "<td align='center'>".$channelinfo['playercount']."</td>\n";
		echo "</tr>";
	} //End foreach
	
	echo "</table>";

closetable();

echo "<br>";


echo "<br>";
// Links table
opentable(TS_LINKS);
echo "<a href='ts_monitor_settings.php'>".TS_SETTINGS."</a>\n";
closetable();

echo "</td>\n";
require_once BASEDIR."footer.php";
?>